image: mcr.microsoft.com/dotnet/core/sdk:3.1

services:
  - docker:dind

build:
  stage: build
  script: 
    - 'cd ./src'
    - 'dotnet restore Otus.Teaching.PromoCodeFactory.sln'
    - 'dotnet build Otus.Teaching.PromoCodeFactory.sln'   

test:
  stage: test
  script:
    - 'dotnet test ./src/Otus.Teaching.PromoCodeFactory.sln'

deploy:
  image: docker:stable
  only:
    - master
  before_script:
    - docker login registry.gitlab.com -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD}
  script:
    - docker build -t ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest src
    - docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest
  after_script:
    - docker logout ${CI_REGISTRY}
  stage: deploy
  tags: 
    - docker
